elftosb::BootImageGenerator Class Referenceabstract

Abstract base class for generators of specific boot image formats. More...

`#include <BootImageGenerator.h>`

Inheritance diagram for elftosb::BootImageGenerator:
[legend]
Collaboration diagram for elftosb::BootImageGenerator:
[legend]

## Public Member Functions

| BootImageGenerator ()
| Constructor.
virtual | ~BootImageGenerator ()
| Destructor.
void | addOutputSection (OutputSection *section)
| Add another section to the output.
void | setOptionContext (OptionContext *context)
| Set the global option context.
virtual BootImage * | generate ()=0
| Pure virtual method to generate the output BootImage from input sections.

## Protected Types

typedef std::vector< OutputSection * > | section_vector_t
| Type for a list of model output sections.

## Protected Member Functions

void | processVersionOptions (BootImage *image)
| Handle common product and component version options.
void | processDriveTagOption (BootImage *image)
| Handle the common option which sets the system drive tag.

## Protected Attributes

section_vector_t | m_sections
| Requested output sections.
OptionContext * | m_options
| Global option context.

## Detailed Description

Abstract base class for generators of specific boot image formats.

Subclasses implement a concrete generator for a certain boot image format, but they all have the same interface.

After creating an instance of a subclass the user adds OutputSection objects to the generator. These objects describe discrete sections within the resulting boot image file. If the format does not support multiple sections then only the first will be used.

Options that are common to all boot image formats are handled by methods defined in this class. These are the current common options:

- productVersion
- componentVersion
- driveTag

The documentation for this class was generated from the following files:

- BootImageGenerator.h
- BootImageGenerator.cpp